/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

/*
*功能描述:创建联系人数据库
*/
public class Contact {//联系人
    private static HashMap<String, String> sContactCache;// sContactCache 是一个静态的 HashMap，用于缓存联系人信息，用于缓存联系人信息的HashMap
    private static final String TAG = "Contact";// TAG 日志标签

    // 定义字符串CALLER_ID_SELECTION
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";// 定义查询条件的字符串

    /*
    * 功能描述：用于获取联系人信息。
    * 输入参数：接受一个上下文参数和一个电话号码参数
    * 返回结果：返回与该电话号码对应的联系人名字
    */
    public static String getContact(Context context, String phoneNumber) {
        if(sContactCache == null) {// 如果联系人缓存为空
            sContactCache = new HashMap<String, String>();// 初始化联系人缓存
        }

        /*
        * 查找HashMap中是否已有phoneNumber信息
        */
        if(sContactCache.containsKey(phoneNumber)) {// 如果在缓存中找到了电话号码对应的联系人信息
            return sContactCache.get(phoneNumber);// 直接从缓存中返回联系人信息
        }

        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));//PhoneNumberUtils.toCallerIDMinMatch() 方法将电话号码转换为最小匹配模式，构建带有电话号码的查询条件
        /*
        * 查找数据库中phoneNumber的信息
        * */
        Cursor cursor = context.getContentResolver().query(
                Data.CONTENT_URI,// 联系人数据的URI
                new String [] { Phone.DISPLAY_NAME },// 要查询的字段，这里是联系人名字
                selection,// 查询条件
                new String[] { phoneNumber },// 查询条件中的占位符对应的值
                null);// 不指定排序
        /*
        * 判定查询结果，如果查询结果不为空且移动到第一条记录，（moveToFirst()返回第一条记录）
        * */
        if (cursor != null && cursor.moveToFirst()) {
            try {// 找到相关信息
                String name = cursor.getString(0);// 获取联系人名字
                sContactCache.put(phoneNumber, name);// 将联系人名字放入缓存
                return name;// 返回联系人名字

            } catch (IndexOutOfBoundsException e) {// 捕获IndexOutOfBoundsException异常
                Log.e(TAG, " Cursor get string error " + e.toString());// 记录异常日志
                return null;// 返回null
            } finally {
                cursor.close();// 关闭查询结果的Cursor
            }
            // 未找到相关信息
        } else {
            Log.d(TAG, "No contact matched with number:" + phoneNumber);// 记录未找到联系人信息的日志
            return null;
        }
    }
}
